#include <stdio.h>
#include <stdlib.h>

#define MAXST 20000

struct poly {
  int st;
  int q[MAXST];
};

void read_poly(int n, struct poly *p)
{
  int i;
  p->st = n;
  for (i = 0; i <= n; i++)
    scanf("%d", &p->q[i]);
}

void normal_poly(struct poly *p)
{
  int i;

  for (i = p->st; i > 0 && !p->q[i]; i--)
    p->st--;
}

void print_poly(struct poly *p)
{
  int i;

  normal_poly(p);
  for (i = 0; i < p->st; i++)
    printf("%d ", p->q[i]);
  printf("%d\n", p->q[p->st]);
}

void clear_poly(struct poly *p)
{
  p->st = 0;
  memset(p->q, 0, MAXST*sizeof(int));
}

void copy_poly(struct poly *dest, struct poly *src)
{
  int i;
  dest->st = src->st;
  for (i = src->st; i >= 0; i--)
    dest->q[i] = src->q[i];
}

void adds(struct poly *res, struct poly *p, int shift, int mul)
{
  int i;

  if (res->st < p->st+shift) {
    for (i = res->st+1; i <= p->st+shift; i++)
      res->q[i] = 0;
    res->st = p->st+shift;
  }
  for (i = 0; i <= p->st; i++)
    res->q[i+shift] += p->q[i]*mul;
}

void mul(struct poly *res, struct poly *p, struct poly *q)
{
  int i;

  clear_poly(res);
  for (i = 0; i <= p->st; i++)
    adds(res, q, i, p->q[i]);
}

void enter(struct poly *res, struct poly *p, struct poly *q)
{
  struct poly tmp[2];
  int actp = 0;
  int i;

  clear_poly(res);
  copy_poly(&tmp[!actp], q);
  for (i = 1; i <= p->st; i++) {
    adds(res, &tmp[!actp], 0, p->q[i]);
    mul(&tmp[actp], &tmp[!actp], q);
    actp = !actp;
  }
  res->q[0] += p->q[0];
}

int main(void)
{
  int z, n, m;
  struct poly p, q, r;

  scanf("%d", &z);
  while (z--)
  {
    scanf("%d %d", &m, &n);
    read_poly(m, &p);
    read_poly(n, &q);
    enter(&r, &p, &q);
    print_poly(&r);
  }
  return 0;
}
