#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LINELEN 256
#define MAXS 210
#define MAXWORDS 2000
#define WORDLEN 21

struct wrd {
  char *str;
  int len;
};

char line[LINELEN];
char osm[MAXS][MAXS];
char used[MAXS][MAXS];
char wordstr[MAXWORDS][WORDLEN];
struct wrd words[MAXWORDS];
int x, y, k;

void ReadOsm(void)
{
  int i;

  gets(line);
  sscanf(line, "%d %d", &y, &x);
  for (i = 0; i < y; i++)
    gets(osm[i]);
}

void nextlet(int *dp, int *hp, char c, int p)
{
  int d = *dp, h = *hp, m;
  int od, oh, med;

  while (d <= h) {
    m = (d+h) >> 1;
    if (words[m].str[p-1] < c)
      d = m+1;
    else if (words[m].str[p-1] > c)
      h = m-1;
    else
      break;
  }
  if (d <= h) {
    med = m;
    od = d; oh = h;
    h = med;
    while (d < h) {
      m = (d+h) >> 1;
      if (words[m].str[p-1] < c)
        d = m + 1;
      else
        h = m;
    }
    *dp = h;
    d = med;
    h = oh;
    while (d < h) {
      m = (d + h + 1) >> 1;
      if (words[m].str[p-1] > c)
        h = m - 1;
      else
        d = m;
    }
    *hp = d;
  }
  else {
    *dp = d;
    *hp = h;
  }
}

void squeeze(void)
{
  int i, shift = 0;

  for (i = 1; i < k; i++) {
    if (words[i-shift-1].len == words[i].len && !strcmp(words[i-shift-1].str, words[i].str))
      shift++;
    else
      words[i-shift] = words[i];
  }
  k -= shift;
}

int cmp(int l, int c, int dy, int dx)
{
  int sp = 0, maxl = 0;
  int d = 0, h = k-1;

  if (d > h)
    return 0;
  while (1) {
    nextlet(&d, &h, osm[l][c], sp+1);
    if (d > h)
      break;
    if (words[d].len == sp+1) {
      maxl = sp+1;
    }
    l += dy;
    if (l == y)
      l = 0;
    else if (l < 0)
      l = y - 1;
    c += dx;
    if (c == x)
      c = 0;
    else if (c < 0)
      l = x - 1;
    sp++;
  }
  return maxl;
}

void scratch(int len, int l, int c, int dy, int dx)
{
  while (len--) {
    used[l][c] = 1;
    l += dy; c += dx;
    if (l == y)
      l = 0;
    else if (l < 0)
      l = y - 1;
    if (c == x)
      c = 0;
    else if (c < 0)
      l = x - 1;
  }
}

void out_words(void)
{
  int i, j, len;

  for (i = 0; i < y; i++)
    for (j = 0; j < x; j++) {
      if ((len = cmp(i, j, 1, 1)))
        scratch(len, i, j, 1, 1);
      if ((len = cmp(i, j, 1, -1)))
        scratch(len, i, j, 1, -1);
      if ((len = cmp(i, j, -1, 1)))
        scratch(len, i, j, -1, 1);
      if ((len = cmp(i, j, -1, -1)))
        scratch(len, i, j, -1, -1);
      if ((len = cmp(i, j, 1, 0)))
        scratch(len, i, j, 1, 0);
      if ((len = cmp(i, j, 0, 1)))
        scratch(len, i, j, 0, 1);
      if ((len = cmp(i, j, -1, 0)))
        scratch(len, i, j, -1, 0);
      if ((len = cmp(i, j, 0, -1)))
        scratch(len, i, j, 0, -1);
    }
}

void gather(void)
{
  int i, j;

  for (i = 0; i < y; i++)
    for (j = 0; j < x; j++)
      if (!used[i][j])
        putchar(osm[i][j]);
  putchar('\n');
}

void Compute(void)
{
  memset(used, 0, y*MAXS);
  out_words();
  gather();
}

int my_strcmp(const void *ap, const void *bp)
{
  const struct wrd *a = ap, *b = bp;
  return strcmp(a->str, b->str);
}

void ReadWords(void)
{
  int i;

  gets(line);
  sscanf(line, "%d", &k);
  memset(wordstr, 0, WORDLEN*k);
  for (i = 0; i < k; i++) {
    words[i].str = wordstr[i];
    gets(words[i].str);
    words[i].len = strlen(words[i].str);
  }
  qsort(words, k, sizeof(struct wrd), my_strcmp);
}

int main(void)
{
  int z;

  gets(line);
  sscanf(line, "%d", &z);
  while (z--) {
    ReadOsm();
    ReadWords();
    squeeze();
    Compute();
  }
  return 0;
}

